package weaver.workflow.workflow;

import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.hrm.company.DepartmentComInfo;
import weaver.hrm.company.SubCompanyComInfo;
import weaver.hrm.job.JobTitlesComInfo;
import weaver.hrm.resource.ResourceComInfo;
import weaver.hrm.roles.RolesComInfo;
import weaver.systeminfo.SystemEnv;

import java.util.List;

/**
 * 转发、意见征询、转办 接收人范围设置
 * @author Administrator
 *
 */
public class WfFwLimitTransMethod extends BaseBean{

	private ResourceComInfo rc = null;
	private DepartmentComInfo dc = null;
	private SubCompanyComInfo sc = null;
	private JobTitlesComInfo jtc = null;
	private RolesComInfo rolec = null;

    public WfFwLimitTransMethod(){
    	try {
			rc = new ResourceComInfo();
			dc = new DepartmentComInfo();
			sc = new SubCompanyComInfo();
			jtc = new JobTitlesComInfo();
			rolec = new RolesComInfo();
		} catch (Exception e) {
			writeLog(e);
		}
	}

	public String getResultCheckBox(String param){
		return "true";
	}

	/**
	 * 类型
	 * @param objtype
	 * @return
	 */
	public String getObjTypeShow(String objtype,String languageid){
		String result = "";
		int langu = Util.getIntValue(languageid, 7);
		switch(Util.getIntValue(objtype)){
		case 0:
			result = SystemEnv.getHtmlLabelName(21837, langu); //本部门
			break;
		case 1:
			result = SystemEnv.getHtmlLabelName(386081, langu); //直接上级部门
			break;
		case 2:
			result = SystemEnv.getHtmlLabelName(386082, langu); //所有上级部门
			break;
		case 3:
			result = SystemEnv.getHtmlLabelName(17587, langu); //下级部门
			break;
		case 4:
			result = SystemEnv.getHtmlLabelName(386083, langu); //所有下级部门
			break;
		case 5:
			result = SystemEnv.getHtmlLabelName(30792, langu); //本分部
			break;
		case 6:
			result = SystemEnv.getHtmlLabelName(386084, langu); //直接上级分部
			break;
		case 7:
			result = SystemEnv.getHtmlLabelName(386085, langu); //所有上级分部
			break;
		case 8:
			result = SystemEnv.getHtmlLabelName(17898, langu); //下级分部
			break;
		case 9:
			result = SystemEnv.getHtmlLabelName(386086, langu); //所有下级分部
			break;
		case 10:
			result = SystemEnv.getHtmlLabelName(19438, langu); //指定部门
			break;
		case 11:
			result = SystemEnv.getHtmlLabelName(19437, langu); //指定分部
			break;
		case 12:
			result = SystemEnv.getHtmlLabelName(81811, langu); //指定人员
			break;
		case 13:
			result = SystemEnv.getHtmlLabelName(382788, langu); //指定角色
			break;
		case 14:
			result = SystemEnv.getHtmlLabelName(382789, langu); //指定岗位
			break;
		case 15:
			result = SystemEnv.getHtmlLabelName(1340, langu); //所有人
			break;
		case 16:
			result = SystemEnv.getHtmlLabelName(10006035, langu); //所有人
			break;
		}
		return result;
	}

	/**
	 * 安全级别
	 * @param seclevel
	 * @param seclevelMax
	 * @return
	 */
	public String getSecLevelShow(int objtype ,String seclevel,String seclevelMax){
		String result = seclevel+"-"+seclevelMax;

		if("".equals(seclevel.trim()) && "".equals(seclevelMax.trim())){
			result = "";
		}
		if(objtype<=9){
		    result = "";
		}

		return result;
	}

	/**
	 * 内容
	 * @param objid
	 * @param parame
	 * @return
	 */
	public String getObjIdsShow(String objid,String param){
		String[] paramArray = Util.splitString(param, "+");
		int objtype = Util.getIntValue(paramArray[0]);
		String rolelevel = paramArray[1];
		String joblevel = paramArray[2];
		String jobobjid = paramArray[3];
		int languageid = Util.getIntValue(paramArray[4],7);
		String result = getObjidShowName(objtype, objid, rolelevel,joblevel, jobobjid, languageid);
		return result;
	}

	public String getObjidShowName(int objtype,String objid,String rolelevel,String joblevel,String jobobjid,int languageid){
		return getObjidShowName(objtype, objid, rolelevel, joblevel, jobobjid, languageid, "0");
	}

	public String getObjidShowName(int objtype,String objid,String rolelevel,String joblevel,String jobobjid,int languageid,String fromAdvance){
		String result = "";
		List<String> list = Util.splitString2List(objid, ",");
		switch(objtype){
		case 0:
		case 1:
		case 2:
		case 3:
		case 4:
		case 5:
		case 6:
		case 7:
		case 8:
		case 9:
		case 15:
			if("1".equals(fromAdvance)){
			    result = getObjTypeShow(objtype+"",languageid+"");
			}
			break;
		case 10://指定部门
			for(int k=0;k<list.size();k++){
				result+= "、"+dc.getDepartmentname(list.get(k));
            }
			if(!"".equals(result)){
				result = result.substring(1);
			}
			break;
        case 16://平行部门
            for(int k=0;k<list.size();k++){
                result+= "、"+dc.getDepartmentname(list.get(k));
            }
            if(!"".equals(result)){
                result = result.substring(1);
            }
            break;
		case 11:
			//指定分部
			for(int k=0;k<list.size();k++){
				result+= "、"+sc.getSubCompanyname(list.get(k));
            }
			if(!"".equals(result)){
				result = result.substring(1);
			}
			break;
		case 12:
			//指定人员
			for(int k=0;k<list.size();k++){
				result+= "、"+rc.getResourcename(list.get(k));
            }
			if(!"".equals(result)){
				result = result.substring(1);
			}
			break;
		case 13:
			//指定角色
			for(int k=0;k<list.size();k++){
				result+= "、"+rolec.getRolesRemark(list.get(k));
			}
			if(!"".equals(result)){
				result = result.substring(1);
			}

			if("0".equals(rolelevel)){
				result += "/"+SystemEnv.getHtmlLabelName(124,languageid);
			}else if("1".equals(rolelevel)){
				result += "/"+SystemEnv.getHtmlLabelName(141,languageid);
			}else if("2".equals(rolelevel)){
				result += "/"+SystemEnv.getHtmlLabelName(140,languageid);
			}
			break;
		case 14:
			//指定岗位
			for(int k=0;k<list.size();k++){
				result+= "、"+jtc.getJobTitlesname(list.get(k));
            }
			if(!"".equals(result)){
				result = result.substring(1);
			}

			if("0".equals(joblevel)){
				result += "/"+SystemEnv.getHtmlLabelName(19438, Util.getIntValue(languageid));
				String depatname = "";
				List<String> list_depat = Util.splitString2List(jobobjid, ",");
				for(int k=0;k<list_depat.size();k++){
					depatname+= "、"+dc.getDepartmentname(list_depat.get(k));
                }
				if(!"".equals(result)){
					depatname = depatname.substring(1);
					result += "（"+depatname+"）";
				}
			}else if("1".equals(joblevel)){
				result += "/"+SystemEnv.getHtmlLabelName(19437, Util.getIntValue(languageid));

				String subcomname = "";
				List<String> list_subcom = Util.splitString2List(jobobjid, ",");
				for(int k=0;k<list_subcom.size();k++){
					subcomname+= "、"+sc.getSubCompanyname(list_subcom.get(k));
                }
				if(!"".equals(result)){
					subcomname = subcomname.substring(1);
					result += "（"+subcomname+"）";
				}

			}else if("2".equals(joblevel)){
				result += "/"+SystemEnv.getHtmlLabelName(140,languageid);
			}
			break;
		}
		return result;
	}

	/**
	 * 内容关系
	 * @param relationship
	 * @return
	 */
	public String getRelationshipShow(String relationship,String languageid){
		String result = "";
		if("0".equals(relationship)){
			result = SystemEnv.getHtmlLabelName(346, Util.getIntValue(languageid, 7));
		}else if("1".equals(relationship)){
			result = SystemEnv.getHtmlLabelName(386080, Util.getIntValue(languageid, 7));
		}

		return result;
	}

	/**
	 * 高级模式-操作者
	 * @param id
	 * @param param
	 * @return
	 */
	public String getOperatorShow(String id,String param){
		String result = "";
		int languageid = Util.getIntValue(param,7);
		String sql = "";
		int oldobjtype = -1;
		RecordSet rs = new RecordSet();
		sql = "select * from workflow_fwoperadvanced where mainid="+id+" order by id";
		rs.execute(sql);
		while(rs.next()){
			int objtype = Util.getIntValue(rs.getString("objtype"));
			int rolelevel = Util.getIntValue(rs.getString("rolelevel"));
			int joblevel = Util.getIntValue(rs.getString("joblevel"));
			String seclevel = Util.null2String(rs.getString("seclevel"));
			String seclevelMax = Util.null2String(rs.getString("seclevelMax"));
			String relationship = Util.null2String(rs.getString("relationship"));

			String objid = Util.null2String(rs.getString("objid"));
			String jobobjid = Util.null2String(rs.getString("jobobjid"));

			if(oldobjtype > -1 && oldobjtype!=objtype){
				result += "；";
			}
			if(oldobjtype > -1 && oldobjtype==objtype){
				result += "，";
			}
			String result0 = getObjidShowName(objtype, objid+"", rolelevel+"",joblevel+"", jobobjid+"", languageid,"1");

			if(objtype == 12){//指定人员
				//String relas = getRelationshipShow(relationship, languageid+"");
				//result0 = "（"+relas+"）"+result0;
			}

			String seclevelStr = getSecLevelShow(objtype,seclevel,seclevelMax);
			if(!"".equals(seclevelStr)){
				result0 += "（"+SystemEnv.getHtmlLabelName(683, languageid)+seclevelStr+"）";
			}
			oldobjtype = objtype;
			result += result0;
		}
		if(!"".equals(result)){
			//result += "；";
		}
		//result ="<a href=\"javaScript:editRow("+id+",0)\">"+ result	+ "</a>";
		return result;
	}

	/**
	 * 高级模式-接收人范围
	 * @param id
	 * @param param
	 * @return
	 */
	public String getRecLimitShow(String id,String param){
		String result = "";
		int languageid = Util.getIntValue(param,7);
		String sql = "";
		int oldobjtype = -1;
		RecordSet rs = new RecordSet();
		sql = "select * from workflow_FwRecAdvanced where mainid="+id+" order by id";
		rs.execute(sql);
		while(rs.next()){
			int objtype = Util.getIntValue(rs.getString("objtype"));
			int rolelevel = Util.getIntValue(rs.getString("rolelevel"));
			int joblevel = Util.getIntValue(rs.getString("joblevel"));
			String seclevel = Util.null2String(rs.getString("seclevel"));
			String seclevelMax = Util.null2String(rs.getString("seclevelMax"));
			String relationship = Util.null2String(rs.getString("relationship"));

			String objid = Util.null2String(rs.getString("objid"));
			String jobobjid = Util.null2String(rs.getString("jobobjid"));

			if(oldobjtype > -1 && oldobjtype!=objtype){
				result += "；";
			}
			if(oldobjtype > -1 && oldobjtype==objtype){
				result += "，";
			}
			String result0 = getObjidShowName(objtype, objid+"", rolelevel+"",joblevel+"", jobobjid+"", languageid,"1");
			String relas = getRelationshipShow(relationship, languageid+"");
			result0 = "（"+relas+"）"+result0;
			String seclevelStr = getSecLevelShow(objtype,seclevel,seclevelMax);
			if(!"".equals(seclevelStr)){
				result0 += "（"+SystemEnv.getHtmlLabelName(683, languageid)+seclevelStr+"）";
			}
			oldobjtype = objtype;

			result += result0;
		}
		if(!"".equals(result)){
			//result += "；";
		}
		//result ="<a href=\"javaScript:editRow("+id+",1)\">"+ result	+ "</a>";
		return result;
	}
}
